#ifndef __GDAM_RECORDER_EXTERNAL_H_
#define __GDAM_RECORDER_EXTERNAL_H_


typedef struct _GdamRecorderExternal GdamRecorderExternal;
typedef struct _GdamRecorderExternalClass GdamRecorderExternalClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "../gdamfilter.h"

GtkType gdam_recorder_external_get_type();
#define GDAM_TYPE_RECORDER_EXTERNAL			(gdam_recorder_external_get_type ())
#define GDAM_RECORDER_EXTERNAL(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_RECORDER_EXTERNAL, GdamRecorderExternal))
#define GDAM_RECORDER_EXTERNAL_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_RECORDER_EXTERNAL, GdamRecorderExternalClass))
#define GDAM_IS_RECORDER_EXTERNAL(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_RECORDER_EXTERNAL))
#define GDAM_IS_RECORDER_EXTERNAL_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_RECORDER_EXTERNAL))


struct _GdamRecorderExternalClass {
	GdamFilterClass		filter_class;
};
struct _GdamRecorderExternal {
	GdamFilter		filter;

	GSList*			recorders;
	gboolean		paused;
	guint			last_output_id;
};

guint gdam_recorder_external_add_fd     (GdamRecorderExternal* recorder,
                                         int                   fd,
					 int                   buffer_size,
					 int                   pid);
guint gdam_recorder_external_run_command(GdamRecorderExternal* recorder,
                                         const char* const*    command,
					 int                   buffer_size);
void  gdam_recorder_external_set_pause  (GdamRecorderExternal* recorder,
                                         guint                 sink_id,
					 gboolean              pause);
void  gdam_recorder_external_kill_sink  (GdamRecorderExternal* recorder,
                                         guint                 sink_id);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
